using System;
using System.Collections.Generic;
using System.Configuration;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace QueryNotificationConsole
{
    class Program
    {
        private static string myConnectionString = ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString;

        static void Main(string[] args)
        {
             SqlDependency.Start(myConnectionString);
            DisplayData();
            Console.ReadLine();
        }

        static void MyOnChanged(object caller, SqlNotificationEventArgs e)
        {
            ConsoleColor originalColor = Console.ForegroundColor;
            Console.ForegroundColor = ConsoleColor.Red;
            Console.WriteLine("SQL Dependency Triggered!");
            Console.ForegroundColor = originalColor;
            Console.WriteLine("Source " + e.Source);
            Console.WriteLine("Type " + e.Type);
            Console.WriteLine("Info " + e.Info);
            DisplayData();
        }

        static void DisplayData()
        {
            using (SqlConnection conn = new SqlConnection(myConnectionString))
            {

                using (SqlCommand cmd =
                  // 2-part table names, no "SELECT * FROM ..."
                new SqlCommand("SELECT CategoryID, CategoryName FROM dbo.[Categories] where categoryid < 5", conn))
                {
                    try
                    {
                        // create dependency associated with cmd
                        SqlDependency depend = new SqlDependency(cmd);
                        // register handler
                        depend.OnChange += new OnChangeEventHandler(MyOnChanged);
                        conn.Open();
                        SqlDataReader rdr = cmd.ExecuteReader();
                        // process DataReader
                        while (rdr.Read())
                        Console.WriteLine(rdr[0]+" - " + rdr[1]);
                        rdr.Close();
                        // Wait for invalidation to come through
                        Console.WriteLine("Press Enter to continue");
                        //Console.ReadLine();
                    }
                    catch (Exception e)
                    { Console.WriteLine(e.Message); }
                }
            }
        }

    }
}
