using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace CacheAPI
{
    public partial class Example1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            BindData();
        }

        private void BindData()
        {
            DataGrid1.DataSource = ListCategories();
            DataGrid1.DataBind();
        }

        // Cache Access Pattern -- BEST PRACTICE
        private DataTable ListCategories()
        {
            string cacheKey = "myCategories";
            object cacheItem = Cache[cacheKey] as DataTable;
            if (cacheItem == null)
            {
                Trace.Warn("Not in cache");

                // Get Data
                SqlConnection conn =
                    new SqlConnection(ConfigurationManager.AppSettings["ConnectionString"].ToString());
                SqlDataAdapter cmd = new SqlDataAdapter("SELECT * FROM dbo.Categories", conn);
                DataTable dt = new DataTable();

                cmd.Fill(dt);
                cacheItem = dt;

                // Important Line Here:
                Trace.Warn("ListCategories", "CacheDuration: " + Globals.CacheDuration.ToString());
                Cache.Insert(cacheKey, cacheItem, null, 
                    DateTime.Now.Add(Globals.CacheDuration),
                    TimeSpan.Zero, 
                    System.Web.Caching.CacheItemPriority.NotRemovable, 
                    null);
                
            }
            else
            {
                Trace.Warn("In cache");
            }

            return (DataTable)cacheItem;
        }

    }
}