<%@ page language="C#"  trace="true" %>
<%@ import namespace="System.Data" %>
<%@ import namespace="System.Data.SqlClient" %>
<script runat="server">
    
    void Page_Load(object sender, System.EventArgs e)
    {
        TimeLabel.Text = DateTime.Now.ToString();
        
        GridView1.DataSource = ListCategories();
        GridView1.DataBind();
    }
    
    DataSet ListCategories()
    {    
        string cacheKey = "CategoriesDS";    
        object cacheItem = Cache[cacheKey] as DataSet;

        if (cacheItem == null)
        {
            Trace.Warn("Not in cache");

            SqlConnection conn = 
                new SqlConnection(ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
            SqlDataAdapter cmd = new SqlDataAdapter("SELECT * FROM dbo.Categories", conn);
            DataSet ds = new DataSet();
            
            cmd.Fill(ds);
            cacheItem = ds;
            // Important Line Here:
            Cache.Insert(cacheKey, cacheItem,
                new SqlCacheDependency("NorthwindDB", "dbo.Categories"));
        }
        else
        {
            Trace.Warn("In cache");
        }
               
        return (DataSet)cacheItem;
    }
</script>

<html>
<head runat="server">
    <title>SqlCacheDependency API</title>
</head>
<body>
    <form runat="server">
        <h1>Cache API w/SQL Dependency</h1>
        <asp:label id="TimeLabel" runat="server">
        </asp:label>&nbsp;<br />
        <b>Time will update every refresh - trace output will show if cache occurred</b>
        &nbsp;
        <asp:gridview id="GridView1" runat="server" bordercolor="Tan" forecolor="Black" borderwidth="1px"
            backcolor="LightGoldenrodYellow" cellpadding="2" gridlines="None">
            <alternatingrowstyle backcolor="PaleGoldenrod" font-italic="False" font-bold="False">
            </alternatingrowstyle>
            <pagerstyle forecolor="DarkSlateBlue" font-italic="False" font-bold="False" horizontalalign="Center"
                backcolor="PaleGoldenrod">
            </pagerstyle>
            <pagersettings mode="NextPrevious">
            </pagersettings>
            <selectedrowstyle forecolor="GhostWhite" backcolor="DarkSlateBlue" font-italic="False"
                font-bold="False">
            </selectedrowstyle>
            <rowstyle font-italic="False" font-bold="False">
            </rowstyle>
            <headerstyle backcolor="Tan" font-italic="False" font-bold="True">
            </headerstyle>
            <footerstyle backcolor="Tan" font-italic="False" font-bold="False">
            </footerstyle>
        </asp:gridview>

    </form>
</body>
</html>
