using System;
using System.Data;
using System.Configuration;
using System.Net;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Threading;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class RequestTest : System.Web.UI.Page
{
    protected DateTime lastModified;
    protected DateTime ifModifiedSince;
    protected HttpStatusCode statusCode;
    protected byte[] contents;
    protected long contentLength;
    protected byte[] hashCode;
    protected WebRequest request;
    protected StreamReader reader;
    protected HttpWebResponse response;
    protected System.Threading.Timer timer;
    protected MD5CryptoServiceProvider hashProvider;

    private string url = "";
    public string Url
    {
        get { return url; }
        set { url = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        hashProvider = new MD5CryptoServiceProvider();
        ifModifiedSince = DateTime.UtcNow;
        this.Url = TextBox1.Text;

        try
        {
            request = WebRequest.Create(url);
            request.Method = DropDownList1.SelectedValue;
            response = (HttpWebResponse)request.GetResponse();

            // store info about the response
            lastModified = response.LastModified;
            LastModifiedLabel.Text = lastModified.ToString();
            statusCode = response.StatusCode;

            ResponseCodeLabel.Text = statusCode.ToString();

            reader = new StreamReader(response.GetResponseStream());
            // check response.ContentEncoding to determine encoding type
            contents = Encoding.UTF8.GetBytes(reader.ReadToEnd());
            contentLength = contents.LongLength;
            hashCode = hashProvider.ComputeHash(contents);

            TextBox2.Text = Encoding.UTF8.GetString(contents);
            LengthLabel.Text = contentLength.ToString();
            HashLabel.Text = Encoding.UTF8.GetString(hashCode);

            TextBox3.Text = "";
            foreach (string header in response.Headers)
            {
                TextBox3.Text += header + Environment.NewLine;
            }

        }
        catch {
            throw;
        }
        finally {
            if(reader!=null)
                reader.Close();
        }
    }
}
