using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace QueryNotificationConsole
{
    class Program
    {


        static void Main(string[] args)
        {
          string connstring = "Data Source=AlienSteve\\SQL2K5;Initial Catalog=Northwind;uid=sa;password=steve";
          using (SqlConnection conn = new SqlConnection(connstring))
          {
              SqlDependency.Start(connstring);

              using (SqlCommand cmd =
                  // 2-part table names, no "SELECT * FROM ..."
               new SqlCommand("SELECT CategoryID, CategoryName FROM dbo.[Categories] where categoryid < 5", conn))
              {
                  try
                  {
                      // create dependency associated with cmd
                      SqlDependency depend = new SqlDependency(cmd);
                      // register handler
                      depend.OnChange += new OnChangeEventHandler(MyOnChanged);
                      conn.Open();
                      SqlDataReader rdr = cmd.ExecuteReader();
                      // process DataReader
                      while (rdr.Read())
                          Console.WriteLine(rdr[0]+" - " + rdr[1]);
                      rdr.Close();
                      // Wait for invalidation to come through
                      Console.WriteLine("Press Enter to continue");
                      Console.ReadLine();
                  }
                  catch (Exception e)
                  { Console.WriteLine(e.Message); }
              }
          }

         Console.ReadLine();
        }
        static void MyOnChanged(object caller, SqlNotificationEventArgs e)
        {
          Console.WriteLine("result has changed");
          Console.WriteLine("Source " + e.Source);
          Console.WriteLine("Type " + e.Type);
          Console.WriteLine("Info " + e.Info);
        }

    }
}
